// Element's MERP Commands
// ---

if(isFile("config/server/MERP/prefs.cs"))
{
	exec("config/server/MERP/prefs.cs");
} else
{
	$Prefs::MERP::empireNameLimit = 40;
	$Prefs::MERP::empireChatPrefix = ">>";
	$Prefs::MERP::chatNamePrefix = "[";
	$Prefs::MERP::chatNameSuffix = "]";
	$Prefs::MERP::timerEnabled = true;
	$Prefs::MERP::logEmpireChat = true;
	$Prefs::MERP::rollColor = "\c3";

	export("$Prefs::MERP::*", "config/server/MERP/prefs.cs");
}


datablock AudioProfile(timerBleep)
{
	description = AudioClosest3D;
	filename = "./timerbleep.wav";
	preload = true;
};

echo("This server is now running Element's MERP Commands!");

exec("./saving.cs");

function serverCmdEmpireName(%client, %name, %name2, %name3, %name4, %name5, %name6, %name7)
{
	%name = %name SPC %name2 SPC %name3 SPC %name4 SPC %name5 SPC %name6 SPC %name7;

	%name = trim(%name);

	if(%name $= "")
	{
		return;
	}

	if(strLen(%name) > $Prefs::MERP::empireNameLimit)
	{
		%client.chatmessage("The name is too long.");
		return;
	}

	if(%client.empireColor $= "")
	{
		%client.empireColor = "FFFFFF";
	}

	if(%client.empireName $= "")
	{
		%client.empireName = %name;

		%client.clanprefix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNamePrefix;
		%client.clansuffix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNameSuffix;

		messageall('',"<color:" @ %client.empireColor @ ">" @ %client.name SPC "\c6has created <color:" @ %client.empireColor @ ">" @ %client.empireName @ "\c6.");

		echo("\c2" @ %client.name SPC "just created" SPC %name);

		return;
	} else
	{
		%oldName = %client.empireName;
		%client.empireName = %name;

		%client.clanprefix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNamePrefix;
		%client.clansuffix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNameSuffix;

		messageall('',"<color:" @ %client.empireColor @ ">" @ %client.name SPC "\c6renamed<color:" @ %client.empireColor @ ">" SPC %oldName SPC "\c6 to <color:" @ %client.empireColor @ ">" @ %client.empireName @ "\c6.");

		echo("\c2" @ %client.name SPC "just renamed" SPC %oldName SPC "to" SPC %name);

		return;
	}
}

function serverCmdEmpireFont(%client, %size, %name, %name2, %name3, %name4, %name5)
{
	%name = %name SPC %name2 SPC %name3 SPC %name4 SPC %name5;

	%name = trim(%name) @ ":" @ %size;

	if(%name $= "")
	{
		return;
	}

	%client.empireFont = %name;

	%client.chatmessage("<font:" @ %client.empireFont @ ">\c6Your empire font has been set to" SPC %name @ ".");

	return;
}

function serverCmdEmpireColor(%client, %hex)
{
	if(%hex $= "")
	{
		%color = %client.player.currSprayCan;

		%colorFromSet = getColorIDTable(%color);

		%colorFromSet = getColorI(%colorFromSet);

		%colorFromSet = removeWord(%colorFromSet, 3);

		%hex = rgbToHex(%colorFromSet);

		%client.empireColor = %hex;

		%client.clanprefix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNamePrefix;
		%client.clansuffix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNameSuffix;

		%client.chatmessage("\c6Your empire color has been set to" SPC "<color:" @ %client.empireColor @ ">" @ %hex @ "\c6.");

		return;
	}

	if(strLen(%hex) != 6)
	{
		%client.chatmessage("You didn't enter a hex code!");

		return;
	}

	if(%client.empireColor $= "")
	{
		%client.empireColor = %hex;

		%client.clanprefix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNamePrefix;
		%client.clansuffix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNameSuffix;

		%client.chatmessage("\c6Your empire color has been set to" SPC "<color:" @ %client.empireColor @ ">" @ %hex @ "\c6.");

		return;
	} else
	{
		%oldColor = %client.empireColor;
		%client.empireColor = %hex;

		%client.clanprefix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNamePrefix;
		%client.clansuffix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNameSuffix;

		%client.chatmessage("\c6You have changed your empire color from <color:" @ %oldColor @ ">" @ %oldColor SPC "\c6to" SPC "<color:" @ %client.empireColor @ ">" @ %hex @ "\c6.");

		return;
	}
}

function serverCmdresetempire(%client)
{
	if(%client.empirename $= "" || %client.empirecolor $= "")
	{
		%client.chatmessage("You don't have an empire to reset!");

		return;
	}

	%oldName = %client.empireName;
	%oldColor = %client.empireColor;

	%client.empirename = "";
	%client.empirecolor = "";

	%client.clanprefix = "<color:FFFFFF>" @ $Prefs::MERP::chatNamePrefix;
	%client.clansuffix = "<color:FFFFFF>" @ $Prefs::MERP::chatNameSuffix;

	%client.chatmessage("\c5You have reset your empire!");
}

function serverCmdRGBToHex(%client, %r, %g, %b)
{
	if(%r $= "" || %g $= "" || %b $= "")
	{
		%client.chatmessage("You need to specify RGB values!");
		return;
	}

	%rgb = %r SPC %g SPC %b;

	%hex = rgbToHex(%rgb);

	%client.chatmessage("\c6RGB2Hex Result:<color:" @ %hex @ ">" SPC %hex);
}

function serverCmdSprayToHex(%client)
{
	%player = %client.player;

	if(!isObject(%player))
	{
		%client.chatmessage("You need to be in-game before you can convert");
		return;
	}

	%color = %player.currSprayCan;

	%colorFromSet = getColorIDTable(%color);

	%colorFromSet = getColorI(%colorFromSet);

	%colorFromSet = removeWord(%colorFromSet, 3);

	%hex = rgbToHex(%colorFromSet);

	%color = "<color:" @ %hex @ ">";

	%client.chatmessage("\c6Spray2Hex Result:" SPC %color @ %hex);
}

package MERP_RollCommand
{
	function serverCmdroll(%client, %sides, %mod)
	{
		if(%sides $= "")
		{
			%client.chatmessage("You need to specify a number of sides!");

			return;
		}

		if(%mod $= "")
		{
			messageAll('', "" @ $Prefs::MERP::rollColor @ %client.name SPC "\c6just rolled" @ $Prefs::MERP::rollColor SPC getRandom(1, %sides) SPC "\c6from a" @ $Prefs::MERP::rollColor SPC %sides @ "-sided \c6die.");

			return;
		}

		%roll = getRandom(1, %sides);

		switch$(getSubStr(%mod,0,1))
		{
			case "+":
				%newMod = stripCharsLoop(%mod, "+ a b c d e f g h i j k m n o p q r s t u v w x y z");

				%oldRoll = %roll;
				%roll += %newMod;

				messageAll('', "" @ $Prefs::MERP::rollColor @ %client.name SPC "\c6just rolled" @ $Prefs::MERP::rollColor SPC %roll SPC "\c6(" @ $Prefs::MERP::rollColor @ %oldRoll @ "+" @ %newMod @ "\c6) from a" @ $Prefs::MERP::rollColor SPC %sides @ "-sided \c6die, with a modifier of" @ $Prefs::MERP::rollColor SPC %mod @ "\c6.");

			case "-":
				%newMod = stripCharsLoop(%mod, "- a b c d e f g h i j k m n o p q r s t u v w x y z");

				%oldRoll = %roll;
				%roll -= %newMod;

				messageAll('', "" @ $Prefs::MERP::rollColor @ %client.name SPC "\c6just rolled" @ $Prefs::MERP::rollColor SPC %roll SPC "\c6(" @ $Prefs::MERP::rollColor @ %oldRoll @ "-" @ %newMod @ "\c6) from a" @ $Prefs::MERP::rollColor SPC %sides @ "-sided \c6die, with a modifier of" @ $Prefs::MERP::rollColor SPC %mod @ "\c6.");

			case "*":
				%newMod = stripCharsLoop(%mod, "* a b c d e f g h i j k m n o p q r s t u v w x y z");

				%oldRoll = %roll;
				%roll = %roll * %newMod;

				messageAll('', "" @ $Prefs::MERP::rollColor @ %client.name SPC "\c6just rolled" @ $Prefs::MERP::rollColor SPC %roll SPC "\c6(" @ $Prefs::MERP::rollColor @ %oldRoll @ "*" @ %newMod @ "\c6) from a" @ $Prefs::MERP::rollColor SPC %sides @ "-sided \c6die, with a modifier of" @ $Prefs::MERP::rollColor SPC %mod @ "\c6.");

			case "/":
				%newMod = stripCharsLoop(%mod, "/ a b c d e f g h i j k m n o p q r s t u v w x y z");

				%oldRoll = %roll;
				%roll = mFloor(%roll / %newMod);

				messageAll('', "" @ $Prefs::MERP::rollColor @ %client.name SPC "\c6just rolled" @ $Prefs::MERP::rollColor SPC %roll SPC "\c6(" @ $Prefs::MERP::rollColor @ %oldRoll @ "/" @ %newMod @ "\c6) from a" @ $Prefs::MERP::rollColor SPC %sides @ "-sided \c6die, with a modifier of" @ $Prefs::MERP::rollColor SPC %mod @ "\c6.");

			default:
				%newMod = stripCharsLoop(%mod, "a b c d e f g h i j k m n o p q r s t u v w x y z");

				if(%newMod > 15)
				{
					return;
				}

				%rolls = "";

				for(%i = 0; %i < %newMod; %i++)
				{
					%roll = getRandom(1, %sides);

					if(%rolls $= "")
					{
						%rolls = %roll;
					} else
					{
						%rolls = %rolls @ "," SPC %roll;
					}
				}

				messageAll('', "" @ $Prefs::MERP::rollColor @ %client.name SPC "\c6just rolled" @ $Prefs::MERP::rollColor SPC %rolls SPC "\c6from a" @ $Prefs::MERP::rollColor SPC %sides @ "-sided \c6die, with a modifier of" @ $Prefs::MERP::rollColor SPC %mod @ "\c6.");
		}

		return;

	}

};

function stripCharsLoop(%string, %chars)
{
	for(%i = 0; %i < getWordCount(%chars); %i++)
	{
		%string = stripChars(%string, getWord(%chars, %i));
	}

	return %string;
}

activatePackage(MERP_RollCommand);

package MERP_TimerCommand
{
	function serverCmdtimer(%client, %delay)
	{
		if(%delay $= "")
		{
			%client.chatmessage("You need to specify a time!");

			return;
		}

		if(%delay $= "cancel")
		{
			cancel(%client.timerSchedule);
			%client.timerScheduleExist = false;

			%client.chatmessage("\c5You have cancelled the timer!");

			return;
		}

		if(%delay < 1)
		{
			%client.chatmessage("A timer this short is not supported.");

			return;
		}

		if(%client.timerScheduleExist)
		{
			%client.chatmessage("You already have a timer running!");

			return;
		} else
		{
			cancel(%client.timerSchedule);

			%client.timerScheduleExist = true;

			%schDelay = %delay * 1000;

			%client.chatmessage("\c5The timer has started! It will last" SPC %delay SPC "second(s) (" @ %schDelay @ "ms).");

			%client.timerSchedule = schedule(%schDelay, 0, endTimerNotification, %client);
		}
	}
};

if($Prefs::MERP::timerEnabled)
{
	activatePackage(MERP_TimerCommand);
}

function endTimerNotification(%client)
{
	%client.chatmessage("\c5The timer ended!");
	%client.play2D(timerBleep);
	%client.timerScheduleExist = false;
}

function serverCmdtoggleroll(%client, %toggle)
{
	if(%client.BL_ID != getNumKeyID())
	{
		%client.chatmessage("You need to be the host to use this command!");

		return;
	}

	if(%toggle $= "")
	{
		%client.chatmessage("You need to specify a state!");

		return;
	}

	if(%toggle $= "on" || %toggle $= "true")
	{
		activatePackage(MERP_RollCommand);
		messageall('',"\c5Rolling has been activated!");

	} else if(%toggle $= "off" || %toggle $= "false")
	{
		messageall('',"\c5Rolling has been deactivated!");
		deactivatePackage(MERP_RollCommand);
	}
}

function serverCmdReloadPrefs(%client)
{
	if(%client.BL_ID != getNumKeyID())
	{
		%client.chatmessage("You need to be the host to use this command!");
	}

	if(isFile("config/server/MERP/prefs.cs"))
	{
		echo("Prefs.cs found! Loading prefs...");
		exec("config/server/MERP/prefs.cs");
	} else
	{
		echo("No Prefs.cs found! Loading and saving default prefs...");

		$Prefs::MERP::empireNameLimit = 40;
		$Prefs::MERP::empireChatPrefix = ">>";
		$Prefs::MERP::chatNamePrefix = "[";
		$Prefs::MERP::chatNameSuffix = "]";
		$Prefs::MERP::timerEnabled = true;
		$Prefs::MERP::rollColor = "\c3";

		export("$Prefs::MERP::*", "config/server/MERP/prefs.cs");
	}

	for(%i = 0; %i < ClientGroup.getCount(); %i++)
	{
		%client = ClientGroup.getObject(%i);

		if(%client.empireColor $= "")
		{
			%client.clanprefix = "<color:FFFFFF>" @ $Prefs::MERP::chatNamePrefix;
			%client.clansuffix = "<color:FFFFFF>" @ $Prefs::MERP::chatNameSuffix;
		} else
		{
			%client.clanprefix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNamePrefix;
			%client.clansuffix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNameSuffix;
		}
	}
}

function serverCmdMERPhelp(%client, %query)
{
	if(%query $= "")
	{
		%client.chatmessage("\c6The sections for this help command are:");
		%client.chatmessage("\c5/MERPhelp empire \c6- This gives you the commands needed to make an empire.");
		%client.chatmessage("\c5/MERPhelp hex \c6- This gives you the hex-code related commands.");
		%client.chatmessage("\c5/MERPhelp roll \c6- This gives you information on rolling.");
		%client.chatmessage("\c5/MERPhelp misc \c6- This gives you miscellaneous commands.");

		return;

	} else if(%query $= "empire")
	{
		%client.chatmessage("\c6The empire commands are:");
		%client.chatmessage("\c5/empirename [name] \c6- This allows you to set your empire's name.");
		%client.chatmessage("\c5/empirecolor [hex code] \c6- This allows you to set your empire's color.");
		%client.chatmessage("\c5/resetempire \c6- This resets your empire.");
		%client.chatmessage("\c6You can use \c5< \c6to type in empire chat.");

		return;

	} else if(%query $= "hex")
	{
		%client.chatmessage("\c6The hex commands are:");
		%client.chatmessage("\c5/rgbtohex [r] [g] [b] \c6- This coverts RGB into a hex-code.");
		%client.chatmessage("\c5/spraytohex \c6- This converts your currently selected paint into a hex-code.");

		return;

	} else if(%query $= "roll")
	{
		%client.chatmessage("\c6The roll commands are:");
		%client.chatmessage("\c5/roll [sides] [modifier] \c6- This rolls a dice with the amount of sides specified, with the modifier.");
		%client.chatmessage("\c6Modifier examples: \c5+1 -1 *2 /2");

	} else if(%query $= "misc")
	{
		%client.chatmessage("\c6The misc commands are:");
		%client.chatmessage("\c5/timer [seconds/cancel] \c6- Starts a timer. If you enter cancel instead of a time, it will cancel the existing timer.");

		return;

	} else
	{
		%client.chatmessage("Enter a valid query!");

		return;
	}
}

package MERP_Commands
{
	function serverCmdMessageSent(%client, %message)
	{
		if(getSubStr(%message,0,2) $= "<<")
		{
			if(%client.empireName $= "")
			{
				return;
			} else
			{
				%c.chatmessage("<font:" @ %client.empireFont @ "> <color:" @ %client.empireColor @ ">[Whisper] " SPC $Prefs::MERP::empireChatPrefix SPC %client.empireName @ "\c6:" SPC getWords(%message,2,100000));
				findClientByName(getWord(%message, 1)).chatmessage("<font:" @ %client.empireFont @ "> <color:" @ %client.empireColor @ ">[Whisper] " SPC $Prefs::MERP::empireChatPrefix SPC %client.empireName @ "\c6:" SPC getWords(%message,2,100000));
				MERP_WriteToLog(%client, %message);
			}
		} else if(getSubStr(%message,0,1) $= "<")
		{
			if(%client.empireName $= "")
			{
				return;
			} else
			{
				messageAll('',"<font:" @ %client.empireFont @ "> <color:" @ %client.empireColor @ ">" SPC $Prefs::MERP::empireChatPrefix SPC %client.empireName @ "\c6:" SPC getSubStr(%message,1,100000));
				MERP_WriteToLog(%client, %message);
			}

		} else if(getSubStr(%message,0,1) !$= "<")
		{
			return Parent::serverCmdMessageSent(%client, %message);
		}
	}

	function GameConnection::AutoAdminCheck(%client)
	{
		%client.chatmessage("\c6This server uses Element's MERP Commands! See /MERPhelp for more info.");

		MERP_LoadEmpire(%client);

		if(%client.empireColor $= ""){
			echo(%client.BL_ID SPC "has no empire color! Loading default...");
			%client.clanprefix = "<color:FFFFFF>" @ $Prefs::MERP::chatNamePrefix;
			%client.clansuffix = "<color:FFFFFF>" @ $Prefs::MERP::chatNameSuffix;
		} else
		{
			echo(%client.BL_ID SPC "has no empire color! Loading saved color...");
			%client.clanprefix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNamePrefix;
			%client.clansuffix = "<color:" @ %client.empireColor @ ">" @ $Prefs::MERP::chatNameSuffix;
		}

		if(%client.empireFont $= ""){
			%client.empireFont = "Palatino Linotype:24";
		}

		return Parent::AutoAdminCheck(%client);
	}

	function GameConnection::onClientLeaveGame(%client)
	{
		cancel(%client.timerSchedule);
		%client.timerScheduleExist = false;

		MERP_SaveEmpire(%client);

		return Parent::onClientLeaveGame(%client);
	}
};

activatePackage(MERP_Commands);

// Ripped off of slayer
function rgbToHex(%rgb)
{
	//use % to find remainder
	%r = getWord(%rgb,0);
	if(%r <= 1)
		%r = %r * 255;
	%g = getWord(%rgb,1);
	if(%g <= 1)
		%g = %g * 255;
	%b = getWord(%rgb,2);
	if(%b <= 1)
		%b = %b * 255;
	%a = "0123456789ABCDEF";

	%r = getSubStr(%a,(%r-(%r % 16))/16,1) @ getSubStr(%a,(%r % 16),1);
	%g = getSubStr(%a,(%g-(%g % 16))/16,1) @ getSubStr(%a,(%g % 16),1);
	%b = getSubStr(%a,(%b-(%b % 16))/16,1) @ getSubStr(%a,(%b % 16),1);

	return %r @ %g @ %b;
}